/*
 *  (c) 2006 by VWP / Oxy
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *----------------------------------------------------------------------
 */


package com.vwp.sound.mod.modplay.loader;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.zip.ZipInputStream;

import com.vwp.sound.mod.modplay.module.Module;

public class ZippedModuleLoader extends ModuleLoader {

	private Module module;

	public ZippedModuleLoader(String name, byte[] data) throws InvalidFormatException, IOException {
		ZipInputStream zi = new ZipInputStream(new ByteArrayInputStream(data));
		zi.getNextEntry();
		module = ModuleLoader.getModuleLoader(
			name.substring(0, name.length() - EXT_ZIP.length()),
			getData(zi)).getModule();
	}

	public Module getModule() {
		return module;
	}

}
