/*
 *  (c) 2006 by VWP / Oxy
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *----------------------------------------------------------------------
 */


package com.vwp.sound.mod.modplay.player;

/**
 * @author torkjel
 *	
 * This class implements a mixer doing simple linear interpolating
 */
public class InterpolatingMixer implements LowLevelMixer
{
	int v1Index, v2Index, v1, v2, inSizeM1;
	double u;
	int outOffset;
	double inOffset;

	public void mix(
		int[] outBuffer,
		int[] outOffsetH,
		int outLength,
		short[] inBuffer,
		double[] inOffsetH,
		int inLength,
		int inSize,
		double grad)
	{

		outOffset = outOffsetH[0];
		inOffset = inOffsetH[0];
		inSizeM1 = inSize-1;

		while (outOffset < outLength && inLength - inOffset > 16)
		{
			v1Index = (int)inOffset;
			v2Index = v1Index + 1;
			v1 = inBuffer[v1Index & inSizeM1];
			v2 = inBuffer[v2Index & inSizeM1];
			u = inOffset - (int)inOffset;
			outBuffer[outOffset++]
				+= (int) ((v1 * (1 - u)) + (v2 * u));
			inOffset += grad;
		}

		inOffsetH[0] = inOffset;
		outOffsetH[0] = outOffset;
	}
}