/*
 *  (c) 2006 by VWP / Oxy
 *  (c) by Torkjel Hongve
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *----------------------------------------------------------------------
 */

package com.vwp.sound.mod.util;

import java.io.*;

public abstract class Util {

    public static String readZeroPaddedString(DataInputStream dis, int length)
            throws IOException {
        byte[] data = new byte[length];
        int nLen = dis.read(data);
        if (nLen != length)
            throw new IOException("can't read zeropaddedstring");
        int len = 0;
        while (len < length && data[len] != 0)
            len++;
        return new String(data, 0, len);
    }

    public static String nibbleToHex(int nibble) {
        nibble &= 0x0f;
        return nibble < 10 ?
            nibble + "" :
            ((char)('A' + nibble - 10)) + "";
    }

    public static int readLEShort(DataInputStream dis) throws IOException {
        return
            ((int) dis.readByte() & 0x0ff) +
            ((int) dis.readByte() & 0x0ff) * 256;
    }

    public static int readLEInt(DataInputStream dis) throws IOException {
        return
            ((int) dis.readByte() & 0x0ff) +
            ((int) dis.readByte() & 0x0ff) * 256 +
            ((int) dis.readByte() & 0x0ff) * 256 * 256 +
            ((int) dis.readByte() & 0x0ff) * 256 * 256 * 256;
    }

    public static void exit(int code) {
        System.exit(code);
    }

}
