/*
 *  (c) 2006 by VWP / Oxy
 *  (c) 2004 by Torkjel Hongve
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *----------------------------------------------------------------------
 */

package com.vwp.sound.mod.util.io;

import java.io.IOException;

/**
 * @author torkjel
 */
public interface RandomAccess {
    public void seek(long pos) throws IOException;
    public void skipBytes(int skip) throws IOException;
    public long getPosition() throws IOException;

    public byte readByte() throws IOException;
    public short readShort() throws IOException;
    public int readInt() throws IOException;
    public int read() throws IOException;

    public String readString(int len) throws IOException;

    /**
     * read a string field of maximum <code>maxLen</code> characters. The string may be shorter,
     * and is then assumed to be padded with zeros. Only the non-zero part is returned, but the
     * position will always be moved maxLen bytes forward.
     * @param maxLen
     * @return
     * @throws IOException
     */
    public String readZeroPaddedString(int maxLen) throws IOException;

    public int readUnsignedInt() throws IOException;

    public int readUnsignedShort() throws IOException;

    public int readUnsignedByte() throws IOException;

    public void close() throws IOException;
}
