/*
 *  (c) 2006 by VWP / Oxy
 *  (c) 2004 by Torkjel Hongve
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *----------------------------------------------------------------------
 */

package com.vwp.sound.mod.util.io;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;


/**
 * @author torkjel
 */
public class RandomAccessFile extends AbstractRandomAccess {

    private java.io.RandomAccessFile raf;

    public RandomAccessFile(File file) throws FileNotFoundException {
        this.raf = new java.io.RandomAccessFile(file,"r");
    }

    public void seek(long pos) throws IOException {
        raf.seek(pos);
    }

    public void skipBytes(int skip) throws IOException {
        raf.skipBytes(skip);
    }

    public long getPosition() throws IOException {
        return raf.getFilePointer();
    }

    public byte readByte() throws IOException {
        return raf.readByte();
    }

    public short readShort() throws IOException {
        return raf.readShort();
    }

    public int readInt() throws IOException {
        return raf.readInt();
    }

    public int read() throws IOException {
        return raf.read();
    }

    public int readUnsignedByte() throws IOException {
        return raf.readUnsignedByte();
    }

    public void close() throws IOException {
        raf.close();
    }
}
